   '****************************************************************************
   '   AVR XPLAIN DAC Demo          (c)2010 W.Krger
   '       Board mit Projekt LUFA modifiziert
   '       http://www.fourwalledcubicle.com/LUFA.php
   '
   '   Bis zu 8 Songs im SDRAM speichern und abspielen
   '
   '   MP3 in WAV konvertieren 11,025kHz / Mono / 8Bit
   '   WAV krzen (ca. 30 - 45 Sekunden) = 300 - 500kB
   '   mit Hex Editor die ersten 46 Byte entfernen
   '   Datei mit 9600 Baud an das XPLAIN bertragen
   '
   '   Bascom 1.11.9.9 Vollversion
   '   Achtung modifizierte "xm128a1def.dat" verwenden
   '    DACB_CH0DATA = 824      ; Channel 0 Data
   '    DACB_CH0DATAL = 824               ; added
   '    DACB_CH0DATAH = 825               ; added
   '
   '    DACB_CH1DATA = 826      ; Channel 1 Data
   '    DACB_CH1DATAL = 826               ; added
   '    DACB_CH1DATAH = 827               ; added
   '****************************************************************************

   $regfile = "xm128a1def.dat"
   $crystal = 32000000                                      '32MHz
   $hwstack = 128
   $swstack = 128
   $framesize = 128
   $lib "xmega.lib"
   $external _xmegafix_clear
   $external _xmegafix_rol_r1014
   Config Osc = Enabled , 32mhzosc = Enabled                'internen 32MHz Oszillator konfigurieren
   Config Sysclock = 32mhz , Prescalea = 1 , Prescalebc = 1_1       'internen 32MHz Oszillator konfigurieren, kein Prescaler

   Config Com1 = 9600 , Mode = Asynchroneous , Parity = None , Stopbits = 1 , Databits = 8
   Open "COM1:" For Binary As #1

   '********** LCD ansteuerung **************************************************************
   'Config Com3 = 100000 , Mode = Asynchroneous , Parity = None , Stopbits = 1 , Databits = 8
   'Open "COM3:" For Binary As #2                            'LCD Ansteuerung
   '*****************************************************************************************

   On Usartc0_rxc Rec_isr , Nosave
   Usartc0_ctrla = Usartc0_ctrla Or &B00010000              'RxC Interrupt enable
   Usartc0_ctrlb = Usartc0_ctrlb Or &B00010000

   Portb_dir = &B00001100                                   'DAC Ausgang
   Porte_dir = &B11111111                                   'PORTE = Output (LED 1-8)
   Porte_out = &B11111111                                   'alle LED's aus

   Portf_dir = &B00000000                                   'Portf = Input
   Portcfg_mpcmask = &B11111111                             'folgendes betrifft alle Portpins
   Portf_pin0ctrl = Bits(4 , 3 , 1)                         'Pullup on Input, fallende Flanke

   Portq_dir = &B00001000
   Portq_out = &B00000000                                   'PQ3 = Audio enable (mit High Pegel)

   Pmic_ctrl = &B00000011                                   'Medium und Low Interrupt

   Dacb_ctrlb = &B01000000                                  'Dual Channel
   Dacb_ctrlc = &B00001001                                  'Ref = AVCC, Left Adjust
   Dacb_timctrl = &B01101111                                'refresh off / 2s Conversion
   Dacb_ctrla = &B00001101                                  'Ch0 + Ch1 enable

   Tcc0_per = &H016B                                        '11,025Khz
   Tcc0_cnt = &H0000
   Tcc0_ctrla = &B00000100                                  'Prescaler 8
   Tcc0_intctrla = &B00000000                               'Interrupt disabled

   Dim Pwm_data As Byte , Temp As Long , Pegel As Byte
   Dim S_adr As Long , _data As Byte , A_flag As Byte
   Dim L_start(8) As Long , S_flag As Byte , Lied As Byte
   Dim L_len(8) As Long , S_adr_old As Long , Play_adr As Long
   Dim Laenge As Long

   On Tcc0_ovf Tim0_irq , Nosave

   '+++++++++++++++++++++++++++ SDRAM Konfiguration ++++++++++++++++++++++++++++

   Porth_out = &H0F

   Porth_dir = &HFF
   Portk_dir = &HFF
   Portj_dir = &HF0

  Ebi_ctrl = &B00001001

  Ebi_cs3_baseaddr = &H0000
  Ebi_sdramctrla = &B00000000

              '2 cycle CAS Latency
              '11 Row bits
              '8 Column bits
  Ebi_sdramctrlb = &B01001001
              '1 cycle Mode Register Delay
              '1 cycle Row Cycle Delay
              '1 cycle Row to Pre-charge Delay
  Ebi_sdramctrlc = &B01001001
              '1 cycle Write Recovery Delay
              '1 cycle Exit Self Refresh to Active Delay
              '1 cycle Row to Column Delay
  Ebi_refresh = &H03FF
               '1023 cycle Refresh Period
  Ebi_initdly = &H0100
               '256 cycle Initialization Delay

  Ebi_cs3_ctrla = &B00111111                                '8MB SDRAM
  While Ebi_cs3_ctrlb.7 = 0
  Wend

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  S_adr = &H4000                                            '1. SDRAM Adresse
  S_adr_old = S_adr
  Lied = 1

Wait 3                                                      'zur LCD initialisierng
Enable Interrupts
'********** LCD ansteuerung ***************************
'Print #2 , Chr(23) ; Chr(1) ; Chr(1) ; "RS232 waiting"
'******************************************************
Print #1 , "RS232 waiting"

'********** HAUPTPROGRAMM ******************************************************

Do

If S_flag = &HFF Then                                       'wenn 23ms keine Daten gekommen sind (bertragung beendet)
   Tcc0_intctrla = 0                                        'Interrupt Timer 0 stoppen
   L_len(lied) = S_adr - S_adr_old                          'Lnge = aktuelle SDRAM Adresse - vorheriger Adresse
   Temp = L_len(lied)
   '********** LCD ansteuerung ***************************
   'Print #2 , Chr(23) ; Chr(1) ; Chr(lied) ; Lied ; " Len: " ; Hex(temp)       'Lied Nr + Lnge anzeigen
   '******************************************************
   Print #1 , Lied ; ".Lied " ; Temp ; " Bytes"
   L_start(lied) = S_adr_old                                'Liedstart = vorherige Adresse
   S_adr_old = S_adr
   If Lied < 8 Then Incr Lied Else Lied = 1                 'Liedanzahl erhhen (1-8)
   S_flag = 0                                               'Empfang fertig bearbeitet
End If

If Pinf <> &HFF Then Gosub Playsong                         'Taste wurde gedrckt

Loop
End

'*******************************************************************************

Playsong:

   _data = Not Pinf                                         'Tasten negieren (gedrckte Taste = "1")
   Select Case _data
      Case 1 : Play_adr = L_start(1)
               Laenge = L_len(1)
      Case 2 : Play_adr = L_start(2)
               Laenge = L_len(2)
      Case 4 : Play_adr = L_start(3)
               Laenge = L_len(3)
      Case 8 : Play_adr = L_start(4)
               Laenge = L_len(4)
      Case 16 : Play_adr = L_start(5)
               Laenge = L_len(5)
      Case 32 : Play_adr = L_start(6)
               Laenge = L_len(6)
      Case 64 : Play_adr = L_start(7)
               Laenge = L_len(7)
      Case 128 : Play_adr = L_start(8)
               Laenge = L_len(8)
   End Select

   Portq_out = &B00001000                                   'Verstrker einschalten
   Temp = 0
   Tcc0_intctrla = 1                                        'Timer 0 aktivieren
   Wait 1
   While Temp <> Laenge                                     'Bytezhler = Songlnge ?

      If A_flag = 1 Then                                    'bei jedem Timer 0 Interrupt 1 Byte abspielen
      Waitus 6

         $asm                                               'keine Ahnung wie man 8MB SDRAM in Bascom auslesen kann
         lds r30,{Play_adr}                                 'deshalb in Assembler
         lds r31,{Play_adr+1}
         lds r20,{Play_adr+2}
         lds r21,{Play_adr+3}
         sts RAMPZ,r20
         LDD r19,Z+0
         sts {pwm_data},r19
         subi r30,&HFF
         sbci r31,&HFF
         sbci r20,&HFF
         sbci r21,&HFF
         sts {Play_adr},r30
         sts {Play_adr+1},r31
         sts {Play_adr+2},r20
         sts {Play_adr+3},r21
         $end Asm

         Dacb_ch0datah = Pwm_data                           'Byte ber DACB Channel 0+1 ausgeben
         Dacb_ch1datah = Pwm_data
         Incr Temp                                          'Bytezhler erhhen (bis Songlnge erreicht ist)
         If Pegel >= 100 Then                               'Pegelanzeige LED's nur alle 9ms aktualiseren
            Select Case Pwm_data
               Case Is <= 128 : Porte_out = &HFF
               Case 129 To 140 : Porte_out = &HEE
               Case 141 To 155 : Porte_out = &HCC
               Case 156 To 170 : Porte_out = &H88
               Case Is >= 171 : Porte_out = &H00
            End Select
         Pegel = 0
         End If
         Incr Pegel
      A_flag = 0
      End If
   Wend
   Porte_out = &HFF                                         'LED's ausschalten
   Portq_out = &B00000000                                   'Verstrker ausschalten
   Tcc0_intctrla = 0                                        'Timer 0 irq sperren
   S_flag = 0                                               'bertragungsflag lschen
Return
'**************** Empfangsroutine **********************************************
'    ACHTUNG es wird nicht geprft, ob 8MB SDRAM berschritten werden !!!
Rec_isr:
  $asm
  push r16
  in R16,SREG
  push r16
  Push r19
  push r20
  push zl
  push zh

  clr r16                                                   'S_flag dient zur Erkennung bertragungsende
  sts {S_flag},r16                                          'whrend der bertragung kontinuierlich S_flag lschen
  ldi r16,1
  sts Tcc0_intctrla,r16                                     'Timer 0 starten / Low Level Interrupt
  lds r16,Usartc0_data                                      'zur berwachung vom bertragungsende
  lds r30,{S_adr}                                           'S_Adr in Z-Register
  lds r31,{S_adr+1}
  lds r19,{S_adr+2}
  lds r20,{S_adr+3}
  sts RAMPZ,r19                                             'bertrag in RAMPZ speichern
  std z+0,r16                                               'empfangenes Byte in SDRAM (Adresse = S_Adr) speichern
  subi r30,&HFF                                             'S_Adr mit bertrag erhhen
  sbci r31,&HFF
  sbci r19,&HFF
  sbci r20,&HFF
  sts {S_adr},r30                                           'S_Adr speichern
  sts {S_adr+1},r31
  sts {S_adr+2},r19
  sts {S_adr+3},r20

  pop zh
  pop zl
  pop r20
  pop r19
  pop r16
  !out SREG,r16
  pop r16
  $end Asm
Return
'**************** Timer 0 Interrupt ********************************************
Tim0_irq:
  $asm
  push r16
  in R16,SREG
  push r16
  push r17
  ldi r17,1
  lds r16,{S_flag}
  cpi r16,&HFF
  breq Tim10
  inc r16
  sts {S_flag},r16                                          'bertragungszhler erhhen
Tim10:                                                      'wenn $FF (23ms kein Byte empfangen) = bertragung beendet
  sts {A_flag},r17                                          'fr Abspielmodus Abspielflag setzen
  pop r17
  pop r16
  !out SREG,r16
  pop r16
  $end Asm
Return
'***************** PROGRAMM ENDE ***********************************************